#include <linux/config.h>
#include <linux/stddef.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/errno.h>
#include <linux/reboot.h>
#include <linux/pci.h>
#include <linux/kdev_t.h>
#include <linux/major.h>
#include <linux/blk.h>
#include <linux/console.h>
#include <linux/delay.h>
#include <linux/irq.h>
#include <linux/ide.h>
#include <linux/irq.h>
#include <linux/seq_file.h>
#include <linux/serial.h>

#include <asm/system.h>
#include <asm/pgtable.h>
#include <asm/page.h>
#include <asm/time.h>
#include <asm/dma.h>
#include <asm/io.h>
#include <asm/machdep.h>
#include <asm/prom.h>
#include <asm/smp.h>
#include <asm/keyboard.h>
#include <asm/vga.h>
#include <asm/open_pic.h>
#include <asm/i8259.h>
#include <asm/todc.h>
#include <asm/bootinfo.h>
#include <asm/mpc10x.h>
#include <asm/pci-bridge.h>

#include "sandpoint.h"
#include "sandpoint_serial.h"
#include <buffalo/miconcntl.h>	/* 2005.5.10 BUFFALO */

//#define MICONMSG

#if defined(CONFIG_HGLAN) || defined(CONFIG_HTGL)
//ppc only
int MiconPortWrite(const unsigned char *buf, int count)
{
	int i;
	int ier;
	const unsigned port_ier=SANDPOINT_SERIAL_0+1;
	const unsigned port_lsr=SANDPOINT_SERIAL_0+5;
	const unsigned port_thr=SANDPOINT_SERIAL_0;
	
	#define TX_EMPTY 0x20
	
	//queuein(buf,count);
	
	ier = in_8(port_ier);
	//printk("ier=%x\n",ier);
	out_8(port_ier, 0);
	for (i=0; i<count; i++){
		unsigned int status, tmout = 1000000;
		do{
			status = in_8(port_lsr);
			if (--tmout == 0)
				break;
		} while ((status & TX_EMPTY) != TX_EMPTY);
		//printk("status=%x tmout=%x\n",status,tmout);
		
		out_8(port_thr, buf[i]);
	}
	out_8(port_ier, ier);
	mdelay(4);		//̃R}hƂ̊ԊuƂ
	return 0;
}
#endif

//--------------------------------------------------------------
void miconCntl_SendCmd(unsigned char dat)
{
	int i;
	unsigned char datas[4];
	datas[0] = dat;
	datas[1] = dat;
	datas[2] = dat;
	datas[3] = dat;
	/*
	static int ddd=0;
	if (ddd++==0){
		printk("UDMB=%02x UFCR=%02x UMCR=%02x ULSR=%02x\n"
			,readb(0x80004500+1)
			,readb(0x80004500+2)
			,readb(0x80004500+4)
			,readb(0x80004500+5)
			);
		printk("UMSR=%02x UDSR=%02x UDCR=%02x\n"
			,readb(0x80004500+6)
			,readb(0x80004500+10)
			,readb(0x80004500+11));
	}
	*/
	
	MiconPortWrite(datas,4);
}

//--------------------------------------------------------------
//FANᑬ]
void miconCntl_FanLow(void)
{
#ifdef MICONMSG
	printk(">%s\n",__FUNCTION__);
#endif
	miconCntl_SendCmd(0x5C);
}
//--------------------------------------------------------------
//FAN]
void miconCntl_FanHigh(void)
{
#ifdef MICONMSG
	printk(">%s\n",__FUNCTION__);
#endif
	miconCntl_SendCmd(0x5D);
}
//--------------------------------------------------------------
//1000Mbps
void miconCntl_Eth1000M(int up)
{
#ifdef MICONMSG
	printk(">%s (%d)\n",__FUNCTION__,up);
#endif
	if (up){
		miconCntl_SendCmd(0x93);
	}else{
		miconCntl_SendCmd(0x92);
	}
}
//--------------------------------------------------------------
//100Mbps
void miconCntl_Eth100M(int up)
{
#ifdef MICONMSG
	printk(">%s (%d)\n",__FUNCTION__,up);
#endif
	if (up){
		miconCntl_SendCmd(0x91);
	}else{
		miconCntl_SendCmd(0x90);
	}
}
//--------------------------------------------------------------
//10Mbps
void miconCntl_Eth10M(int up)
{
#ifdef MICONMSG
	printk(">%s (%d)\n",__FUNCTION__,up);
#endif
	if (up){
		miconCntl_SendCmd(0x8F);
	}else{
		miconCntl_SendCmd(0x8E);
	}
}
//--------------------------------------------------------------
//Ȃ̃R}hH
void miconCntl_5f(void)
{
#ifdef MICONMSG
	printk(">%s\n",__FUNCTION__);
#endif
	miconCntl_SendCmd(0x5F);
	mdelay(100);
}
//--------------------------------------------------------------
void miconCntl_Rebooting(void)
{
#ifdef MICONMSG
	printk(">%s\n",__FUNCTION__);
#endif
	miconCntl_SendCmd(0x43);
}
//--------------------------------------------------------------
void miconCntl_RadiRecovery(void)
{
#ifdef MICONMSG
	printk(">%s\n",__FUNCTION__);
#endif
	MiconPortWrite("aa8041",6);
	
}
//--------------------------------------------------------------
void miconCntl_RadiRecoveryFin(void)
{
#ifdef MICONMSG
	printk(">%s\n",__FUNCTION__);
#endif
	miconCntl_SendCmd(0x70);
}

//--------------------------------------------------------------
void miconCntl_BlinkLed(unsigned char state)
{
#ifdef MICONMSG
	printk(">%s\n",__FUNCTION__);
#endif
#ifdef CONFIG_HTGL
	switch (state)
	{
		case FLASH_CLEAR_START:
		case FLASH_UPDATE_START:
			MiconPortWrite("aa8041",6);
			MiconPortWrite("aa8141",6);
			MiconPortWrite("qqss",4);
			break;
		case FLASH_CLEAR_END:
		case FLASH_UPDATE_END:
			MiconPortWrite("pprr",4);
			break;
		case HDD_NOT_PRESENT:
			MiconPortWrite("mmmm",4);
			break;
	}
#else
	unsigned char datas[4];
	datas[0] = state;
	datas[1] = state;
	datas[2] = state;
	datas[3] = state;
	MiconPortWrite(datas,4);
#endif
}

EXPORT_SYMBOL(MiconPortWrite);

